<template>
  <div>
    <v-tabs height="40" v-model="tab" background-color="grey lighten-2">
      <template v-for="(itemTab, indexItemTab) in tabs">
        <v-tab :key="'tab' + indexItemTab">
          {{ itemTab.name }}
          <v-btn
            v-if="indexItemTab != 0"
            @click="removeTab(indexItemTab)"
            icon
            color="grey"
          >
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-tab>
        <v-tab-item
          :style="{ height: heightTabContent + 'px' }"
          :key="'tab-item' + indexItemTab"
          :value="indexItemTab"
        >
          <TabContent :index-item-tab="indexItemTab" :item-tab="itemTab" />
        </v-tab-item>
      </template>
    </v-tabs>
  </div>
</template>
<script>
import TabContent from "@/views/secure/pro/TabContent.vue";
export default {
  name: "Component-WorkTabs",
  props: {
    properties: Object
  },
  components: {
    TabContent
  },
  data: () => ({
    tab: null,
    tabs: [
      {
        name: "Home"
      }
    ],
    heightTabContent: window.innerHeight - 137
  }),
  methods: {
    addTab(connection) {
      this.properties.connection = connection;
      const tabConnection = {
        plsql: "",
        name: connection.name,
        isOutError: false,
        outError: null,
        outParams: {
          grids: [],
          simple: []
        },
        isLoading: false,
        setPlsql: (value, itemTab) => {
          itemTab.plsql = value;
        },
        setParams(value, itemTab) {
          itemTab.params = value;
        },
        clearOutParams: (itemTab) => {
          itemTab.outParams = {
            grids: [],
            simple: []
          };
        },
        clearOutError(itemTab) {
          itemTab.isOutError = false;
          itemTab.outError = null;
        },
        params: [],
        isDialogParams: false,
        properties: this.properties
      };
      this.tabs.push(tabConnection);
      this.tab = this.tabs.length - 1;
    },
    removeTab(inIndexItemTab) {
      this.tabs = this.tabs.filter(
        (itemTab, indexItemTab) => inIndexItemTab != indexItemTab
      );
    },
    windowResize() {
      this.heightTabContent = window.innerHeight - 137;
    }
  },
  mounted() {
    this.$root.$on("newConnection", this.addTab);
    window.addEventListener("resize", this.windowResize);
  }
};
</script>
